var SimpleMail, storage;
var folders = window.arguments[0].inn.folders;
var folderTree = window.arguments[0].inn.folderTree;

function initialize() {
  SimpleMail = SimpleMailUtils.getBrowserWindow().SimpleMail;
  storage = SimpleMail.storage;
  populateAccountId();
  today = new Date();
  SimpleMailPrefs.setString('dateValue', today);
  SimpleMailDom.get("accountId").selectedIndex=0;
}
   
function choice(selectedIndex) {
  if (SimpleMailDom.get("choice").selectedIndex == 0) {
    SimpleMailDom.get("accountId").disabled = false;
  }  
  else if (SimpleMailDom.get("choice").selectedIndex == 1){
    SimpleMailDom.get("accountId").disabled = true;
  }
} 

function archiveType(selectedIndex) {
  if (SimpleMailDom.get("archiveType").selectedIndex == 1) {
      SimpleMailDom.get('deletemessages').checked = false;
      SimpleMailDom.get("deletemessages").disabled = true;
  }
  else {
    SimpleMailDom.get("deletemessages").disabled = false;
  }
}
  
function browseDataDirectory() {
  var file = SimpleMailFile.chooseFile("folder");
  if (file) {
    SimpleMailDom.get("dataDirectory").value = file.path;
    SimpleMailPrefs.setString("dataDirectory", file.path);
  }
}

function populateAccountId() {
  var accounts = storage.getAccounts();
  var popup = SimpleMailDom.get("accountId").menupopup;

  for(var i = 0; i < accounts.length; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", accounts[i]);
    menuitem.setAttribute("value", accounts[i].id);
    popup.appendChild(menuitem);
  }
  popup.parentNode.selectedIndex = 0;
}

function updateWindow() {
  if ((SimpleMailDom.get("archiveType").selectedIndex == 1)) {
    var archiveType = SimpleMailDom.get("archiveType").selectedIndex;
    window.arguments[0].out = {archiveType:archiveType};
    close();
  }
  else {
    close();
  }
}

function next() {
  var deck = SimpleMailDom.get("stateDeck");
  var index = deck.getAttribute("selectedIndex");
  switch (index) {
  case "0":
  deck.setAttribute("selectedIndex", "1");
  case "1":
  okDialog();
  break;
  case "2":
  updateWindow();
  break;  
  }
}    

function okDialog() {
if ((SimpleMailDom.get("archiveType").selectedIndex == 1)) {
  if (outputFolder() == true) {
    ShowResults(true);
    return(true);
  }
    else {
    setProgress(5);
    return(false);
  }
  ShowResults(false);
}

if (outputFile() == true) {
    ShowResults(true);
    return(true);
  }
  else {
    setProgress(5);
    return(false);
  }
  ShowResults(false);
}

function setProgress (pct) {
  if (pct <= 100) {
    var progressMeter = SimpleMailDom.get("progressMeter");
    progressMeter.value =  pct;
   }
  return; 
}
   
function attachStrings(aNode, aString) {
  var attachNode = SimpleMailDom.get(aNode);
  var strings = aString.split("\n");
  
  for (var i = 0; i < strings.length; i++) {
    if (strings[i]) {
      var currNode = document.createTextNode(strings[i]);
      attachNode.appendChild(currNode);
      var br = document.createElementNS("http://www.w3.org/1999/xhtml", 'br');
      attachNode.appendChild(br);
    }
  }
}

function ShowResults(good) {
  var result;
  
  if (good) {
    result = SimpleMailBundle.getString("createdArchive");
  }
  else {
    result = SimpleMailBundle.getString("errorArchive");
  }
  attachStrings("results", result);
  var deck = SimpleMailDom.get("stateDeck");
  deck.setAttribute("selectedIndex", "2");
  var nextButton = SimpleMailDom.get("forward");
  nextButton.label = nextButton.getAttribute("finishedval");
  nextButton.removeAttribute("disabled");
  var cancelButton = SimpleMailDom.get("cancel");
  cancelButton.setAttribute("hidden", "true");
}

function getString(statement, id) {
  var text = "text: ";
  var value = statement.getString(id);
  return value && value.substr(0, text.length) == text ? value.substr(text.length) : value;
}

function outputFile() {
  var deck = SimpleMailDom.get("stateDeck");
  var dateValue = new Date(SimpleMailPrefs.getString('dateValue'));
  if (new Date(SimpleMailPrefs.getString('dateValue')) > today ){
    var confirmText = SimpleMailBundle.getString("archiveAlert");
      if (!SimpleMailUtils.confirm(confirmText)) {
        deck.setAttribute("selectedIndex", "0");
        return;
      }
   }
   
//Get msgs for account   
  if (SimpleMailDom.get("choice").selectedIndex == 0) {
    var selectedAccount = SimpleMailDom.get("accountId").selectedItem.value;
    var Accountlabel = SimpleMailDom.get("accountId").selectedItem.label;

    var msg = new Array();  
    var msg = SimpleMail.storage.getAccountMessages(selectedAccount);
    
    var messagesDate = new Array();
    for(var i = msg.length - 1; i >= 0; i--) {    
      if ((msg[i].date)< dateValue) {
        messagesDate.push(msg[i]);
      }
    }
  }
  else {
//Get msgs for selected folder
    var folder = window.arguments[0].inn.folder;
    //Get msgs in subfolders
    var msg = new Array();
    forEachFolder(folder, function(f) {
      msg = msg.concat(storage.getFolderMessages(f.id));
    });
    
    var messagesDate = new Array();
    for(var i = msg.length - 1; i >= 0; i--) {    
      if ((msg[i].date)< dateValue) {
        messagesDate.push(msg[i]);
      }
    }    
  }
  setProgress(10);
        
//Check if messages exists 
  if (msg.length < 1 || messagesDate.length < 1) {
    var confirmText = SimpleMailBundle.getString("nomailAlert");
    SimpleMailUtils.alert(confirmText);
    deck.setAttribute("selectedIndex", "0");
    return;    
  }
    
//Create file    
  if ((SimpleMailDom.get("archiveType").selectedIndex == 0)) {
    var file = Components.classes["@mozilla.org/file/directory_service;1"]
               .getService(Components.interfaces.nsIProperties)
               .get("TmpD", Components.interfaces.nsIFile);
    file.append("simplemail.tmp");
    file.createUnique(file.NORMAL_FILE_TYPE, 0666);
    if (!file) {
      deck.setAttribute("selectedIndex", "0");
      return;
    }     
  }
  else if ((SimpleMailDom.get("archiveType").selectedIndex == 1)) {
    outputFolder();
    if (!file) {
      deck.setAttribute("selectedIndex", "0");
      return;
    } 
  }
  else if ((SimpleMailDom.get("choice").selectedIndex == 0) && (SimpleMailDom.get("archiveType").selectedIndex == 2)) {
    var file = SimpleMailFile.chooseFile("save", [], Accountlabel+SimpleMailDate.toShortString(dateValue));
    if (!file) {
      deck.setAttribute("selectedIndex", "0");
      return;
    } 
  }
  else if ((SimpleMailDom.get("choice").selectedIndex == 1) && (SimpleMailDom.get("archiveType").selectedIndex == 2)) {
    var file = SimpleMailFile.chooseFile("save", [], folder.getName()+" - "+SimpleMailDate.toShortString(dateValue));
    if (!file) {
      deck.setAttribute("selectedIndex", "0");
      return;
    } 
  }
    
  var out = SimpleMailFile.createOutputStream(file);
  setProgress(20);
  
//Write file
  for(var i = msg.length - 1; i >= 0; i--) {
    if ((msg[i].date)< dateValue) {
      var source = SimpleMailFile.getAttachmentsDirectory(msg[i].attachmentsDir);
      source.append(SimpleMailFile.MESSAGE_SOURCE);
      out.write("From - " + new Date(msg[i].date) + "\r\n");
      out.write(SimpleMailFile.readFile(source) + "\r\n\r\n");
      setProgress(30);
    }   
  }
  out.close();
  setProgress(40);
  
//Zip file
  if (SimpleMailDom.get("archiveType").selectedIndex == 0) {
    const PR_RDWR        = 0x04
	  const PR_CREATE_FILE = 0x08
	  const PR_TRUNCATE    = 0x20
	  const COMPRESSION_BEST    = 9;
    var zipWriter = Components.Constructor("@mozilla.org/zipwriter;1","nsIZipWriter");
    var zipW = new zipWriter();
    
    if (SimpleMailDom.get("choice").selectedIndex == 0){
      var out = SimpleMailFile.chooseFile("save", ["*.zip"], Accountlabel+SimpleMailDate.toShortString(dateValue)+".zip");
      if (!out) {
        deck.setAttribute("selectedIndex", "0");
        file.remove(true);
        return;
      }
    }
    else {
      var out = SimpleMailFile.chooseFile("save", ["*.zip"], folder.getName()+" - "+SimpleMailDate.toShortString(dateValue)+".zip");
      if (!out) {
        deck.setAttribute("selectedIndex", "0");
        file.remove(true);
        return;
      } 
    }
       
   var zipfile = SimpleMailFile.getNsiFile(out);
   var file = SimpleMailFile.getNsiFile(file);

   zipW.open(zipfile, PR_RDWR | PR_CREATE_FILE | PR_TRUNCATE);
   
   //filezip = zipfile.path.replace(/\\/g,"/");
   path = out.leafName.slice(0, -4);
   setProgress(50);
   zipW.addEntryFile(path, Components.interfaces.nsIZipWriter.COMPRESSION_BEST, file, false);
   zipW.close();
   file.remove(true);
   setProgress(60);
  }
  setProgress(70);
  
//Delete messages
  if (SimpleMailDom.get('deletemessages').checked) {
    var msgs = new Array();
      for(var i = msg.length - 1; i >= 0; i--) {
        if ((msg[i].date)< dateValue) {
          msgs.push(msg[i]);
        }
      setProgress(80);        
      }
    var confirmText = SimpleMailBundle.getString("deleteMessages");
    SimpleMail.askDeleteMail(msgs, confirmText, window);
    setProgress(80);
  }
  setProgress(90);
  return(true);
}

//Archive in folder
function outputFolder() {
  var deck = SimpleMailDom.get("stateDeck");
  var dateValue = new Date(SimpleMailPrefs.getString('dateValue'));
  if (new Date(SimpleMailPrefs.getString('dateValue')) > today ){
    var confirmText = SimpleMailBundle.getString("archiveAlert");
      if (!SimpleMailUtils.confirm(confirmText)) {
        deck.setAttribute("selectedIndex", "0");
        return;
      }
   }
   
//Get msgs for account   
  if (SimpleMailDom.get("choice").selectedIndex == 0) {
    var selectedAccount = SimpleMailDom.get("accountId").selectedItem.value;
    var Accountlabel = SimpleMailDom.get("accountId").selectedItem.label;

    var msg = new Array();  
    var msg = SimpleMail.storage.getAccountMessages(selectedAccount);
    
    var messagesDate = new Array();
    for(var i = msg.length - 1; i >= 0; i--) {    
      if ((msg[i].date)< dateValue) {
        messagesDate.push(msg[i]);
      }
    }
  }
  else {
//Get msgs for selected folder
    var folder = window.arguments[0].inn.folder;
    //Get msgs in subfolders
    var msg = new Array();
    forEachFolder(folder, function(f) {
      msg = msg.concat(storage.getFolderMessages(f.id));
    });
    
    var messagesDate = new Array();
    for(var i = msg.length - 1; i >= 0; i--) {    
      if ((msg[i].date)< dateValue) {
        messagesDate.push(msg[i]);
      }
    }    
  }
  setProgress(10);
        
//Check if messages exists 
  if (msg.length < 1 || messagesDate.length < 1) {
    var confirmText = SimpleMailBundle.getString("nomailAlert");
    SimpleMailUtils.alert(confirmText);
    deck.setAttribute("selectedIndex", "0");
    return;    
  }

//Create folder
  var name = {};
  if (SimpleMailUtils.prompt("folderName", name) && name.value) {
  //Check if Archives folder exist
    var archiveFolder = name.value;
    var file = SimpleMailFile.getDataDirectory();
    file.append("simplemail.sqlite");

    var storageService = Components.classes["@mozilla.org/storage/service;1"]
                       .getService(Components.interfaces.mozIStorageService);
    var connection = storageService.openDatabase(file);
  
    var statement = connection.createStatement("SELECT id, parentId, name, open FROM folders");
    try {
      var foldersNames = new Array();
      var foldersId = new Array();
      while(statement.executeStep()) {
        var id = statement.getInt32(0);
        var name = getString(statement, 2);
        foldersNames.push(name);
        foldersId.push(id);
      }
    }  
    finally {
      statement.reset();
    }

    for(var i = foldersNames.length - 1; i >= 0; i--) {
      if ((foldersNames[i]==archiveFolder)) {
        var confirmText = SimpleMailBundle.getString("alreadyExist");
        SimpleMailUtils.alert(confirmText);
        deck.setAttribute("selectedIndex", "0");
        return;
      }
    }
  }  
//Write Folder    
    var folderA = new SimpleMailFolder(null, null, archiveFolder);
    folderTree = window.arguments[0].inn.folderTree;
    folderTree.view = folderTreeView; 
    setFolderParent(folderA, 0);

//Move Messages
  for(var i = msg.length - 1; i >= 0; i--) {
    if ((msg[i].date)< dateValue) {
      msg[i].folderId = folderA.id;
      storage.saveMessageState(msg[i]);
    }
  setProgress(60);
  }   
  setProgress(90);
  return(true);
}
    